"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// src/node/useNodeWorker.ts
var import_node_worker_threads = __toESM(require("worker_threads"));
var import_node_path = __toESM(require("path"));
var import_node_process = __toESM(require("process"));
var import_node_fs = __toESM(require("fs"));

// src/is/isArray.ts
var isArray = Array.isArray;

// src/node/useNodeWorker.ts
function useProcressNodeWorker(callback) {
  const { parentPort } = import_node_worker_threads.default;
  parentPort.on("message", async (data) => parentPort == null ? void 0 : parentPort.postMessage(await (callback == null ? void 0 : callback(data)) || (() => "")));
}

// src/node/jsShell.ts
var import_node_child_process = __toESM(require("child_process"));
var import_node_process2 = __toESM(require("process"));
function jsShell(commander, options = "inherit") {
  let args = [];
  let stdio = "inherit";
  let errorExit = true;
  let isLog = false;
  let cwd;
  if (typeof options === "string") {
    stdio = options;
  } else {
    args = options.args ?? [];
    stdio = options.stdio ?? "inherit";
    errorExit = options.errorExit ?? true;
    isLog = options.isLog ?? false;
    cwd = options.cwd;
  }
  return isArray(commander) ? commander.map((command) => executor(command)) : executor(commander);
  function executor(commander2) {
    var _a;
    const { status, output, stdout, stderr, error, signal, pid } = import_node_child_process.default.spawnSync(commander2, args, {
      shell: true,
      encoding: "utf8",
      stdio: stdio === "inherit" ? "inherit" : ["inherit", "pipe", "inherit"],
      cwd
    });
    const result = (_a = output[1]) == null ? void 0 : _a.trim();
    if (status === 130) {
      if (isLog)
        console.log("\u5DF2\u53D6\u6D88...");
      return { status, result };
    }
    if (status !== 0) {
      if (isLog)
        console.log(result || (error == null ? void 0 : error.message));
      if (errorExit)
        import_node_process2.default.exit(1);
    }
    return {
      status,
      result,
      stdout,
      stderr,
      error,
      signal,
      pid
    };
  }
}

// src/worker/useNodeWorkerThread.ts
useProcressNodeWorker(
  ({ params, ...args }) => jsShell(`${params}`, Object.assign({ stdio: "pipe" }, args))
);
